import socket, sys
from tkinter import messagebox

class Sub_Server:
    def __init__(self, indirizzo, backlog = 2):
        self.sub_server(indirizzo, backlog)
    def ricevi_comandi(self):
        while True:
            richiesta = self.conn.recv(4096)
            r = richiesta.decode()
            data = 'Ok, ho ricevuto {}'.format(r)
            self.conn.send(data.encode('utf-8'))

    def sub_server(self, indirizzo, backlog):
        try:
            self.s = socket.socket()
            self.s.bind(indirizzo)
            self.s.listen(backlog)
            print('In ascolto')
        except (KeyboardInterrupt, SystemExit):
            messagebox.showinfo('Chiusura', 'hai chiuso il terminale')
            self.chiusura()
        except socket.error as errore:
            print('Errore... \n{}'.format(errore))
            print('Ritento...')
            self.sub_server(indirizzo, backlog = 1)
        self.conn, self.indirizzo_client = self.s.accept()
        print('Connesso a: {}'.format(self.indirizzo_client))
        self.ricevi_comandi()

    def chiusura(self):
        self.conn.sendall('Server chiuso'.encode('utf-8'))
        self.conn.close()
        sys.exit()

if __name__ == '__main__':
    SS = Sub_Server(('', 4115))
